using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using MagSiteLib;

namespace MagSite
{
	/// <summary>
	/// AdminEditDef ̊Tv̐łB
	/// </summary>
	public class AdminEditDef : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label LabelKeyword;
		protected System.Web.UI.WebControls.Button ButtonSubmit;
		protected System.Web.UI.WebControls.TextBox TextBoxHeadText;
		protected System.Web.UI.WebControls.Label LabelAlterHeadText;
		protected System.Web.UI.WebControls.TextBox TextBoxFootText;
		protected System.Web.UI.WebControls.Label LabelAlterFootText;
		protected System.Web.UI.WebControls.CheckBox CheckBoxHeaderTextType;
		protected System.Web.UI.WebControls.CheckBox CheckboxFootTextType;
		protected System.Web.UI.WebControls.TextBox TextBoxSystemMessageTitle;
		protected System.Web.UI.WebControls.Label LabelAlterSystemMessageTitle;
		protected System.Web.UI.WebControls.TextBox TextBoxNewContentsTitle;
		protected System.Web.UI.WebControls.Label LabelAlterNewContentsTitle;
		protected System.Web.UI.WebControls.TextBox TextBoxTopContentsTitle;
		protected System.Web.UI.WebControls.Label LabelAlterTopContentsTitle;
		protected System.Web.UI.WebControls.TextBox TextBoxTopKeywordsTitle;
		protected System.Web.UI.WebControls.Label LabelAlterTopKeywordsTitle;
		protected System.Web.UI.WebControls.TextBox TextBoxChildKeywordsTitle;
		protected System.Web.UI.WebControls.Label LabelAlterChildKeywordsTitle;
		protected System.Web.UI.WebControls.TextBox TextBoxContentsListTitle;
		protected System.Web.UI.WebControls.Label LabelAlterContentsListTitle;
		protected System.Web.UI.WebControls.TextBox TextBoxLinkTitle;
		protected System.Web.UI.WebControls.Label LabelAlterLinkTitle;
		protected System.Web.UI.WebControls.TextBox TextBoxAdminstratorMailAddress;
		protected System.Web.UI.WebControls.Label LabelAlterAdminstratorMailAddress;
		protected System.Web.UI.WebControls.TextBox TextBoxTitlePictureURI;
		protected System.Web.UI.WebControls.Label LabelAlterTitlePictureURI;
		protected System.Web.UI.WebControls.TextBox TextBoxStyleSheetURI;
		protected System.Web.UI.WebControls.Label LabelAlterStyleSheetURI;
		protected System.Web.UI.WebControls.TextBox TextboxHeadText;
		protected System.Web.UI.WebControls.TextBox TextboxFootText;
		protected System.Web.UI.WebControls.TextBox TextboxSystemMessageTitle;
		protected System.Web.UI.WebControls.TextBox TextboxNewContentsTitle;
		protected System.Web.UI.WebControls.TextBox TextboxTopContentsTitle;
		protected System.Web.UI.WebControls.TextBox TextboxTopKeywordsTitle;
		protected System.Web.UI.WebControls.TextBox TextboxChildKeywordsTitle;
		protected System.Web.UI.WebControls.TextBox TextboxContentsListTitle;
		protected System.Web.UI.WebControls.TextBox TextboxLinkTitle;
		protected System.Web.UI.WebControls.TextBox TextboxAdminstratorMailAddress;
		protected System.Web.UI.WebControls.TextBox TextboxTitlePictureURI;
		protected System.Web.UI.WebControls.TextBox TextboxStyleSheetURI;
		protected System.Web.UI.WebControls.Label LabelAlterTitle;
		protected System.Web.UI.WebControls.Label LabelAlterAdminstratorName;
		protected System.Web.UI.WebControls.Label LabelAlterSmtpServerHostName;
		protected System.Web.UI.WebControls.Label LabelAlterAutoReportMailAddress;
		protected System.Web.UI.WebControls.TextBox TextBoxAdminstratorName;
		protected System.Web.UI.WebControls.TextBox TextBoxSmtpServerHostName;
		protected System.Web.UI.WebControls.TextBox TextBoxAutoReportMailAddress;
		protected System.Web.UI.WebControls.TextBox TextBoxShortKeyword;
		protected System.Web.UI.WebControls.TextBox TextBoxPeruAssociateID;
		protected System.Web.UI.WebControls.Label LabelAlterPeruAssociateID;
		protected System.Web.UI.WebControls.TextBox TextBoxTitle;
		protected System.Web.UI.WebControls.Label LabelPeruName;
		protected System.Web.UI.WebControls.Panel PanelPeruMenu;

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.ButtonSubmit.Click += new System.EventHandler(this.ButtonSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.Init += new System.EventHandler(this.AdminEditDef_Init);

		}
		#endregion

		public string CssUrl = "default.css";

		private string createAlterText( string text )
		{
			return "<br>󗓂ɂꍇ: <strong>" + Server.HtmlEncode(text) + "</strong>";
		}

		private string createAlterMultiLineText( string text )
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			sb.Append("<br>󗓂ɂꍇ: ");
			StringReader reader = new StringReader(text);
			while( true )
			{
				string s = reader.ReadLine();
				if( s == null ) break;
				sb.Append("<br><strong>" + Server.HtmlEncode(s) + "</strong>");
			}
			return sb.ToString();
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			Authorization.ConfirmAccessPermission(User.Identity.Name,URIQueryParser.ParseKeyword(Request));
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request);
			SectionDef def = SectionDefManager.GetSectionDef(keyword);
			this.CssUrl = def.StyleSheetURI;
		}

		private void AdminEditDef_Init(object sender, System.EventArgs e)
		{
#if KINOLABO
			this.PanelPeruMenu.Visible = false;
#endif
			this.LabelPeruName.Text = SpecialResource.PeruAssociateIDJ;
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request);

			RawSectionDef rawdef = SectionDefManager.GetSectionDef(keyword).GetRawSectionDef();
			SectionDef parentDef = SectionDefManager.GetSectionDef(keyword.GetParentKeyword());

			LabelKeyword.Text = Server.HtmlEncode( WriteLib.KeywordToHumanReadableString(keyword) );
			
			TextBoxTitle.Text = rawdef.Title;
			LabelAlterTitle.Text = createAlterText(parentDef.Title);

			CheckBoxHeaderTextType.Checked = rawdef.HeadTextType == EBodyType.XhtmlByText;

			TextBoxHeadText.Text = rawdef.HeadText;
			LabelAlterHeadText.Text = createAlterMultiLineText(parentDef.HeadText);

			CheckboxFootTextType.Checked = rawdef.FootTextType == EBodyType.XhtmlByText;

			TextBoxFootText.Text = rawdef.FootText;
			LabelAlterFootText.Text = createAlterText(parentDef.FootText);

			TextBoxFootText.Text = rawdef.FootText;
			LabelAlterFootText.Text = createAlterMultiLineText(parentDef.FootText);

			TextBoxSystemMessageTitle.Text = rawdef.SystemMessageTitle;
			LabelAlterSystemMessageTitle.Text = createAlterText(parentDef.SystemMessageTitle);

			TextBoxNewContentsTitle.Text = rawdef.NewContentsTitle;
			LabelAlterNewContentsTitle.Text = createAlterText(parentDef.NewContentsTitle);

			TextBoxTopContentsTitle.Text = rawdef.TopContentsTitle;
			LabelAlterTopContentsTitle.Text = createAlterText(parentDef.TopContentsTitle);

			TextBoxTopKeywordsTitle.Text = rawdef.TopKeywordsTitle;
			LabelAlterTopKeywordsTitle.Text = createAlterText(parentDef.TopKeywordsTitle);

			TextBoxChildKeywordsTitle.Text = rawdef.ChildKeywordsTitle;
			LabelAlterChildKeywordsTitle.Text = createAlterText(parentDef.ChildKeywordsTitle);

			TextBoxContentsListTitle.Text = rawdef.ContentsListTitle;
			LabelAlterContentsListTitle.Text = createAlterText(parentDef.ContentsListTitle);

			TextBoxLinkTitle.Text = rawdef.LinkTitle;
			LabelAlterLinkTitle.Text = createAlterText(parentDef.LinkTitle);

			TextBoxAdminstratorMailAddress.Text = rawdef.AdminstratorMailAddress;
			LabelAlterAdminstratorMailAddress.Text = createAlterText(parentDef.AdminstratorMailAddress);

			TextBoxTitlePictureURI.Text = rawdef.TitlePictureURI;
			LabelAlterTitlePictureURI.Text = createAlterText(parentDef.TitlePictureURI);

			TextBoxStyleSheetURI.Text = rawdef.StyleSheetURI;
			LabelAlterStyleSheetURI.Text = createAlterText(parentDef.StyleSheetURI);

			TextBoxAdminstratorName.Text = rawdef.AdminstratorName;
			LabelAlterAdminstratorName.Text = createAlterText(parentDef.AdminstratorName);

			TextBoxAutoReportMailAddress.Text = rawdef.AutoReportMailAddress;
			LabelAlterAutoReportMailAddress.Text = createAlterText(parentDef.AutoReportMailAddress);

			TextBoxSmtpServerHostName.Text = rawdef.SmtpServerHostName;
			LabelAlterSmtpServerHostName.Text = createAlterText(parentDef.SmtpServerHostName);

			TextBoxPeruAssociateID.Text = rawdef.PeruAssociateID;
			LabelAlterPeruAssociateID.Text = createAlterText(parentDef.PeruAssociateID);

			TextBoxShortKeyword.Text = rawdef.ShortKeyword;
		}

		private void RedirectResult(string message,FullKeyword keyword)
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			sb.Append(FileNames.AdminFn);
			sb.Append("?msg=");
			sb.Append(Server.UrlEncode(message));
			sb.Append("&kw=");
			sb.Append(Server.UrlEncode(keyword.EncodedKeyword));
			Response.Redirect(sb.ToString());
		}

		private void ButtonSubmit_Click(object sender, System.EventArgs e)
		{
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request);
			
			RawSectionDef rawdef = SectionDefManager.GetSectionDef(keyword).GetRawSectionDef();
			
			rawdef.Title = TextBoxTitle.Text;
			rawdef.HeadTextType = this.CheckBoxHeaderTextType.Checked ? EBodyType.XhtmlByText : EBodyType.PlaneText;

			rawdef.HeadText = TextBoxHeadText.Text;
			rawdef.FootTextType = this.CheckboxFootTextType.Checked ? EBodyType.XhtmlByText : EBodyType.PlaneText;
			rawdef.FootText = TextBoxFootText.Text;
			rawdef.SystemMessageTitle = TextBoxSystemMessageTitle.Text;
			rawdef.NewContentsTitle = TextBoxNewContentsTitle.Text;
			rawdef.TopContentsTitle = TextBoxTopContentsTitle.Text;
			rawdef.TopKeywordsTitle = TextBoxTopKeywordsTitle.Text;
			rawdef.ChildKeywordsTitle = TextBoxChildKeywordsTitle.Text;
			rawdef.ContentsListTitle = TextBoxContentsListTitle.Text;
			rawdef.LinkTitle = TextBoxLinkTitle.Text;
			rawdef.AdminstratorMailAddress = TextBoxAdminstratorMailAddress.Text;
			rawdef.TitlePictureURI = TextBoxTitlePictureURI.Text;
			rawdef.StyleSheetURI = TextBoxStyleSheetURI.Text;
			rawdef.AdminstratorName = TextBoxAdminstratorName.Text;
			rawdef.SmtpServerHostName = TextBoxSmtpServerHostName.Text;
			rawdef.AutoReportMailAddress = TextBoxAutoReportMailAddress.Text;
			rawdef.PeruAssociateID = TextBoxPeruAssociateID.Text;

			if( rawdef.ShortKeyword != TextBoxShortKeyword.Text )
			{
				if( TextBoxShortKeyword.Text!= "" && ShortKeywordFinder.IsShortKeyword( TextBoxShortKeyword.Text ) )
				{
					RedirectResult("ZO [" + TextBoxShortKeyword.Text
						+ "] ͊ɎgpĂ܂BWebuEÚu߂v{^Ŗ߂ĕύXĉB",
						keyword);
					return;
				}
			}
			rawdef.ShortKeyword = TextBoxShortKeyword.Text;
			rawdef.Update();

			RedirectResult("ύX܂B",keyword);
		}
	}
}
