using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using NestedHtmlWriter;
using MagSiteLib;

namespace MagSite
{
	public class Pic : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			int number = URIQueryParser.ParseNumber(Request);

			Item item = GeneralContentsHandler.GetItem( URIQueryParser.ParseID(Request) );
			Item.AttachedFile targetFile = null;
			foreach( Item.AttachedFile attachedFile in item.AttachedFiles )
			{
				if( attachedFile.Number == number )
				{
					targetFile = attachedFile;
					break;
				}
			}
			if( targetFile == null )
			{
				throw new ApplicationException("wԍ[" + number.ToString() + "]̓Ytt@C܂B");
			}

			SectionDef def = SectionDefManager.GetSectionDef(item.Keyword);
			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, targetFile.Name, item.Keyword ) )
			{
				doc.B.WriteHxText(1,targetFile.Name);
				using( NhP p = doc.B.CreateP() )
				{
					using( NhImg img = p.CreateImg() )
					{
						img.WriteClassAttr( "attachedPicture" );
						img.WriteAttribute( "src",
							WriteLib.CreateAttachedFileURI(item.ItemID,targetFile.FileName,URIQueryParser.ParseWidth(Request)) );
						img.WriteAttribute( "alt", targetFile.Name );
					}
				}
				using( NhP p = doc.B.CreateP() )
				{
					string returnURI = string.Empty;
					if( URIQueryParser.ParseRet(Request).Length > 0 )
					{
						returnURI = URIQueryParser.ParseRet(Request);
					}
					else if( item.ItemID.IsNormalItemID() )
					{
						returnURI = FileNames.Content + "?id=" + item.ItemID;
					}
					if( returnURI != string.Empty )
					{
						p.WriteText("[");
						p.WriteAText(returnURI,"߂");
						p.WriteText("]");
					}
					WriteLib.CreatePictureSizeMenuItem(p,item.ItemID,targetFile,returnURI);
				}
#if false
				else
				{
					doc.B.WritePText("Õy[Wɖ߂ꍇ́AWebuEU̖߂{^Ŗ߂ĉB");
				}
#endif
				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteNormalFooter(doc.B,item.Keyword);
			}
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
