#define QUICK_HACK_FOR_RECOMPILATION

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using NestedHtmlWriter;
using MagSiteLib;
using AWebProcedureFramework;

namespace MagSite
{
	public class AdminFn : System.Web.UI.Page
	{
		private string myName = "@\s";
		private FullKeyword keyword = FullKeyword.NoKeyword;
		private ItemID itemID = ItemID.NoItem;

		private void showMesssageSub( string [] messages )
		{
			const string title = "ʂ̃|[g";
			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, title, keyword ) )
			{
				using( NhHx h1 = doc.B.CreateHx(1) )
				{
					h1.WriteText(title);
				}

				foreach( string message in messages )
				{
					doc.B.WritePText(message);
				}
				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private void showMesssageSub( string message )
		{
			ArrayList list = new ArrayList();
			StringReader reader = new StringReader(message);
			while( true )
			{
				string s = reader.ReadLine();
				if( s == null ) break;
				list.Add(s);
			}
			showMesssageSub( (string[])list.ToArray(typeof(string)) );
		}

		private void showMesssage()
		{
			string message = "(bZ[W͂܂)";
			if( Request["msg"] != null )
			{
				message = Request["msg"];
			}

			showMesssageSub(message);
		}

		private void error( string message )
		{
			string [] messages = 
				{
					"G[ (" + myName + ")",
					message
				};
			showMesssageSub( messages );
		}

		private void addKeyword()
		{
			myName = "L[[h̒ǉ";

			if( Request["new"] == null )
			{
				error( "쐬L[[hw肳Ă܂Bǉ͍s܂B" );
				return;
			}
			if( Request["new"].Trim().Length == 0 )
			{
				error( "쐬L[[hw肳Ă܂Bǉ͍s܂B" );
				return;
			}
			if( Request["sk"] == null )
			{
				error( "쐬ZOw肳Ă܂Bǉ͍s܂B" );
				return;
			}
			if( Request["sk"].Trim().Length == 0 )
			{
				error( "쐬ZOw肳Ă܂Bǉ͍s܂B" );
				return;
			}
			if( ShortKeywordFinder.IsShortKeyword(Request["sk"].Trim()) )
			{
				error( "w肳ꂽZO͊ɎgĂ܂Bǉ͍s܂B" );
				return;
			}

			string [] newKW = new string[keyword.Keywords.Length+1];
			for( int i=0; i<keyword.Keywords.Length; i++ )
			{
				newKW[i] = keyword.Keywords[i];
			}
			newKW[keyword.Keywords.Length] = Request["new"].Trim();
			FullKeyword newKeyword = new FullKeyword(newKW);

			if( ItemListManager.ContentList.IsKeyword(newKeyword) )
			{
				error( "w肳ꂽL[[h͊ɑ݂܂Bǉ͍s܂B" );
				return;
			}

			string shortKeyword = Request["sk"].Trim();

			SectionDef def = SectionDefManager.AddKeyword(newKeyword);
			def.GetRawSectionDef().ShortKeyword = shortKeyword;
			def.Update();	// o^m̂߂̕K{菇 (t@C)

			keyword = newKeyword;
			showMesssageSub("L[[h:" + WriteLib.KeywordToHumanReadableString(newKeyword) + "̐VK쐬܂B");
		}

		private void fillShortKeyword()
		{
			ArrayList resultReport = new ArrayList();
			resultReport.Add("ZOo^ĂȂSẴL[[hɂĒZO蓖Ă܂B");
			FullKeyword [] keywords = ItemListManager.ContentList.GetKeywordList();
			foreach( FullKeyword keyword in keywords )
			{
				if( keyword.IsRootKeyword() ) continue;
				if( keyword.IsNoKeyword() ) continue;
				SectionDef def = SectionDefManager.GetSectionDef(keyword);
				if( def.ShortKeyword == "" )
				{
					def.GetRawSectionDef().ShortKeyword = ShortKeywordFinder.GetNewShortKeyword();
					def.Update();
					resultReport.Add( string.Format("L[[h{0}ɒZO{1}蓖Ă܂B",
						WriteLib.KeywordToHumanReadableString(keyword),def.ShortKeyword) );
				}
			}
			resultReport.Add("܂B");
			showMesssageSub((string[])resultReport.ToArray( typeof(string)));
		}

		private bool deleteKeywordCheckSub( FullKeyword keyword, NhBlock block )
		{
			if( keyword.IsRootKeyword() )
			{
				block.WritePText("̃L[[h͍폜ł܂B");
				block.WritePText("ŏʃL[[h͍폜ł܂B");
				return false;
			}
			else if( !ItemListManager.ContentList.IsTerminalKeyword(keyword) )
			{
				block.WritePText("̃L[[h͍폜ł܂B");
				block.WritePText("qL[[hL[[h͍폜ł܂B");
				block.WritePText("Ƃ΁AABƂL[[hƂAA폜ɂ́AB폜Kv܂B");
				return false;
			}
			else if( !GeneralContentsHandler.IsNoItemKeyword(keyword) )
			{
				block.WritePText("̃L[[h͍폜ł܂B");
				block.WritePText("Rec܂܂L[[h폜邱Ƃ͂ł܂B");
				block.WritePText("Recɂ́A쐬̃htgRec܂݂܂B");
				block.WritePText("̃L[[h폜ɂ́Aɂ̃L[[hɑRec폜ĉB");
				return false;
			}
			return true;
		}


		private void deleteKeywordConfirm()
		{
			myName = "L[[h폜mF";

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, keyword ) )
			{
				doc.B.WriteHxText(1,myName);

				if( deleteKeywordCheckSub( keyword, doc.B ) )
				{
					doc.B.WritePText("L[[h폜悤ƂĂ܂B");
					doc.B.WritePText("{ɍ폜ꍇ́AĹu{ɍ폜ṽNNbNĂB");
					doc.B.WritePText("폜Ȃꍇ͑̃y[WֈړĂB");

					using( NhP p = doc.B.CreateP() )
					{
						p.WriteText("[");
						using( NhA a = p.CreateA() )
						{
							WriteLib.WriteHrefAttr(a,keyword,ItemID.NoItem,FileNames.AdminFn,"delkw");
							a.WriteText("{ɍ폜");
						}
						p.WriteText("]");
					}
					using( NhP p = doc.B.CreateP() )
					{
						p.WriteText("폜Ώۂ̃L[[h: ");
						p.WriteText(WriteLib.KeywordToHumanReadableString(keyword));
					}
				}
				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private void deleteKeyword()
		{
			myName = "L[[h폜s";

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, keyword ) )
			{
				doc.B.WriteHxText(1,myName);

				if( deleteKeywordCheckSub( keyword, doc.B ) )
				{
					KeywordAccessRanking.RemoveKeyword(keyword);
					SectionDefManager.RemoveByKeyword(keyword);
					ItemListManager.ContentList.RemoveKeywordFromIndexes(keyword);
					ShortKeywordFinder.RemoveByKeyword(keyword);
					doc.B.WritePText("L[[h͍폜܂B");

					using( NhP p = doc.B.CreateP() )
					{
						p.WriteText("폜ꂽL[[h: ");
						p.WriteText(WriteLib.KeywordToHumanReadableString(keyword));
					}
				}
				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,FullKeyword.NoKeyword);
			}
		}

		private void deleteContentConfirm()
		{
			myName = "Rec폜mF";

			if( itemID.IsNoItem() )
			{
				error("IDw肳Ă܂B͍s܂B");
				return;
			}
			Item item = GeneralContentsHandler.GetItem(itemID);
			if( item.IsDummyItem() )
			{
				error("wIDɊYRec͂܂B͍s܂B");
				return;
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, item.Keyword ) )
			{
				doc.B.WriteHxText(1,myName);
				doc.B.WritePText("Rec폜悤ƂĂ܂B");
				doc.B.WritePText("{ɍ폜ꍇ́AĹu{ɍ폜ṽNNbNĂB");
				doc.B.WritePText("폜Ȃꍇ͑̃y[WֈړĂB");
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteAText(FileNames.AdminFn + "?fn=delcont&id=" + itemID.ID,"{ɍ폜");
				}
				doc.B.WriteHxText(2,"폜Ώۂ̃Rec");
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("L[[h: ");
					p.WriteText(WriteLib.KeywordToHumanReadableString(item.Keyword));
				}
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("t: ");
					if( itemID.IsDraftItemID() )
					{
						p.WriteText(DraftManager.GetItemTimeStamp(itemID).ToString("yyyyNMMddHHmmssb") );
					}
					else
					{
						p.WriteText(item.Date.ToString("yyyyNMMddHHmmssb") );
					}
				}
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("^Cg: ");
					p.WriteText(item.Subject);
				}
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("_CWFXg: ");
					p.WriteText(item.GetDigestText());
				}

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,item.Keyword);
			}
		}

		private void deleteContent()
		{
			myName = "Rec폜s";

			if( itemID.IsNoItem() )
			{
				error("IDw肳Ă܂B͍s܂B");
				return;
			}
			Item item = GeneralContentsHandler.GetItem(itemID);
			if( item.IsDummyItem() )
			{
				error("wIDɊYRec͂܂B͍s܂B");
				return;
			}

			if( itemID.IsDraftItemID() )
			{
				DraftManager.Remove( itemID );
			}
			else
			{
				ItemListManager.ContentList.Remove( itemID );
			}
			itemID = ItemID.NoItem;

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, keyword ) )
			{
				doc.B.WriteHxText(1,myName);
				doc.B.WritePText("Rec̍폜͊܂B");

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private void writeMasterIDInfo( NhBlock block )
		{
			using( NhP p = block.CreateP() )
			{
				p.WriteText("Ṽ}X^[ID: ");
				p.WriteText(Request["new"]);
			}

			block.WriteHxText(2," (Kǂ݉)");

			block.WritePText("@}X^[ID́A}X^[̔F؂̑ΏۂƂȂIDłBʂ̏ݗpIDƂ͈قȂ̂łB");
			block.WritePText("@F؉\ID̒A1IDw肵ĂB");
			block.WritePText("@}X^[ID𑶍݂ȂIDɕύX邱Ƃł܂B"
				+ "̏ꍇA}X^[IDŔF؂邱Ƃs\ɂȂ܂B"
				+ "ύX͐TdɍsĂBIDݒ肵ꍇ̉񕜂̎菇́Areadme.txtQƂĂB");
			block.WritePText("@}X^[ID̕ύXɐƁAF؏񂪖ɂȂAēxOIv܂B"
				+ "͐ȓł̂ŁAVIDŃOIĂB");
		}

		private void changeMasterIDConfirm()
		{
			myName = "}X^[IDύXmF";
			Authorization.ConfirmMasterAccessPermission(User.Identity.Name);

			if( Request["new"] == null || Request["new"].Trim().Length == 0 )
			{
				error( "V}X^[IDw肳Ă܂BύX͍s܂B" );
				return;
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, FullKeyword.NoKeyword ) )
			{
				doc.B.WriteHxText(1,myName);

				doc.B.WritePText("}X^[IDύX悤ƂĂ܂B");
				doc.B.WritePText("{ɕύXꍇ́AĹu{ɕύXṽNNbNĂB");
				doc.B.WritePText("ύXȂꍇ͑̃y[WֈړĂB");

				using( NhP p = doc.B.CreateP() )
				{
					System.Text.StringBuilder sb = new System.Text.StringBuilder();
					sb.Append(FileNames.AdminFn);
					sb.Append("?fn=changemasterid&new=");
					sb.Append(Server.UrlEncode(Request["new"]));
					p.WriteText("[");
					p.WriteAText(sb.ToString(),"{ɕύX");
					p.WriteText("]");
				}

				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("݂̃}X^[ID: ");
					p.WriteText(AuthMasterFile.ID);
				}

				writeMasterIDInfo( doc.B );

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,FullKeyword.NoKeyword);
			}
		}

		private void changeMasterID()
		{
			myName = "}X^[IDύX";

			Authorization.ConfirmMasterAccessPermission(User.Identity.Name);

			if( Request["new"] == null || Request["new"].Trim().Length == 0 )
			{
				error( "V}X^[IDw肳Ă܂BύX͍s܂B" );
				return;
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, FullKeyword.NoKeyword ) )
			{
				doc.B.WriteHxText(1,myName);

				AuthMasterFile.ID = Request["new"].Trim();
				AuthMasterFile.Update();

				doc.B.WritePText("}X^[IDύX܂B");

				writeMasterIDInfo( doc.B );

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,FullKeyword.NoKeyword);
			}

			System.Web.Security.FormsAuthentication.SignOut();
		}

		private void addGeneralID()
		{
			myName = "ʃC^[ID̒ǉ";

			Authorization.ConfirmMasterAccessPermission(User.Identity.Name);

			if( Request["new"] == null || Request["new"].Trim().Length == 0 )
			{
				error( "VʃC^[IDw肳Ă܂Bw͍s܂B" );
				return;
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, keyword ) )
			{
				doc.B.WriteHxText(1,myName);

				SectionDef def = SectionDefManager.GetSectionDef(keyword);
				def.GetRawSectionDef().GeneralAuthrizationIDs.Add(Request["new"].Trim());
				def.Update();

				doc.B.WritePText("ʃC^[IDǉ܂B");
				doc.B.WritePText("ǉꂽID:");
				doc.B.WritePText(Request["new"].Trim());

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private void deleteGeneralIDConfirm()
		{
			myName = "ʃC^[ID폜mF";

			SectionDef def = SectionDefManager.GetSectionDef(keyword);
			Authorization.ConfirmMasterAccessPermission(User.Identity.Name);

			if( Request["generalid"] == null || Request["generalid"].Trim().Length == 0 )
			{
				error( "폜ʃC^[IDw肳Ă܂B폜͍s܂B" );
				return;
			}

			if( !def.GetRawSectionDef().GeneralAuthrizationIDs.Contains(Request["generalid"].Trim()) )
			{
				error( "w肳ꂽʃC^[ID܂B폜͍s܂B" );
				return;
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, keyword ) )
			{
				doc.B.WriteHxText(1,myName);

				doc.B.WritePText("ʃC^[ID폜悤ƂĂ܂B");
				doc.B.WritePText("{ɍ폜ꍇ́AĹu{ɍ폜ṽNNbNĂB");
				doc.B.WritePText("폜Ȃꍇ͑̃y[WֈړĂB");

				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("[");
					using( NhA a = p.CreateA() )
					{
						WriteLib.WriteHrefAttr(a,keyword,ItemID.NoItem,FileNames.AdminFn,"delgeneralid",
							"generalid",Request["generalid"].Trim());
						a.WriteText("{ɍ폜");
					}
					p.WriteText("]");
				}
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("폜Ώۂ̈ʃC^[ID: ");
					p.WriteText(Request["generalid"].Trim());
				}

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private void deleteGeneralID()
		{
			myName = "ʃC^[ID폜s";

			SectionDef def = SectionDefManager.GetSectionDef(keyword);
			Authorization.ConfirmMasterAccessPermission(User.Identity.Name);

			if( Request["generalid"] == null || Request["generalid"].Trim().Length == 0 )
			{
				error( "폜ʃC^[IDw肳Ă܂B폜͍s܂B" );
				return;
			}

			if( !def.GetRawSectionDef().GeneralAuthrizationIDs.Contains(Request["generalid"].Trim()) )
			{
				error( "w肳ꂽʃC^[ID܂B폜͍s܂B" );
				return;
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, keyword ) )
			{
				doc.B.WriteHxText(1,myName);

				def.GetRawSectionDef().GeneralAuthrizationIDs.Remove(Request["generalid"].Trim());
				def.Update();

				doc.B.WritePText("ʃC^[ID폜܂B");
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("폜ꂽʃC^[ID: ");
					p.WriteText(Request["generalid"].Trim());
				}

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		class errorPageException : ApplicationException
		{
			public errorPageException()
			{
			}
			public errorPageException(	string message ) : base(message)
			{
			}
			protected errorPageException( System.Runtime.Serialization.SerializationInfo info,
				System.Runtime.Serialization.StreamingContext context )
				: base( info, context )
			{
			}
			public errorPageException( string message, Exception innerException )
				: base( message, innerException )
			{
			}
		}

		private string getTrackBackUrlToDelete()
		{
			if( Request["url"] == null || Request["url"].Trim().Length == 0 )
			{
				throw new errorPageException("폜TrackBack ping URLw肳Ă܂B폜͍s܂B" );
			}
			string urlToRemove = Request["url"].Trim();

			Item item = GeneralContentsHandler.GetItem(itemID);
			if( !item.GetPendingTrackBackUrls().Contains(urlToRemove) )
			{
				throw new errorPageException("w肳ꂽTrackBack ping URL܂B폜͍s܂B" );
			}
			return urlToRemove;
		}

		private const string deletingTrackBackUrlWarnText = "WebuEÚA"
			+ "iށA߂ACɓȂǂ͍̑sȂ悤A肢܂B"
			+ "sƁAȌTrackBack pingMsȂȂ܂B"
			+ "MsȂTrackBack ping URL"
			+ "uߋɑMG[ŃyfBOw肳ꂽgbNobNꗗvɎc܂B"
			+ "ēxRec̕ҏWIсAURLugbNobNMΏۂƂȂgbNobNURLv"
			+ "ړɁAuށv{^NbNƍđMł܂B";

		private void deleteTrackBackRequestConfirm()
		{
			myName = "TrackBack ping URL폜mF";
			Item item = GeneralContentsHandler.GetItem(itemID);
			string urlToRemove = getTrackBackUrlToDelete();

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, item.Keyword ) )
			{
				doc.B.WriteHxText(1,myName);
				doc.B.WritePText("폜URL: " + urlToRemove );
				doc.B.WritePText("{ɍ폜ꍇ́Aȉ[{ɍ폜]NbNĉB");
				doc.B.WritePText("폜Ȃꍇ́Aȉ[폜ȂTrackBack pingM𑱂]NbNĉB"
					+ "IꍇAURĹAuߋɑMG[ŃyfBOw肳ꂽgbNobNꗗvɎc܂B");
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("[");
					p.WriteAText(FileNames.AdminFn + "?fn=deltbreq&id=" + item.ItemID + "&url=" + HttpUtility.UrlEncode(urlToRemove),"{ɍ폜");
					p.WriteText("][");
					p.WriteAText( WriteLib.BuildUrlToSendingTrackBackProcedure(TrackBackProcedure.TrackBackSendWebProcItem,item.ItemID),
						"폜ȂTrackBack pingM𑱂");
					p.WriteText("]");
				}
				doc.B.WritePText(deletingTrackBackUrlWarnText);
			}
		}

		private void deleteTrackBackRequest()
		{
			myName = "TrackBack ping URL폜s";
			Item item = GeneralContentsHandler.GetItem(itemID);
			string urlToRemove = getTrackBackUrlToDelete();
			lock( item )
			{
				item.RemovePendingTrackBackUrl(urlToRemove);
				item.Update();
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, item.Keyword ) )
			{
				doc.B.WriteHxText(1,myName);
				doc.B.WritePText("TrackBack ping URL͐ɍ폜܂BB");
				doc.B.WritePText("폜ꂽURL: " + urlToRemove );
				doc.B.WritePText("L[TrackBack pingM𑱂]NbNčƂ𑱂ĉB");
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("[");
					p.WriteAText( WriteLib.BuildUrlToSendingTrackBackProcedure(TrackBackProcedure.TrackBackSendWebProcItem,item.ItemID),
						"TrackBack pingM𑱂");
					p.WriteText("]");
				}
				doc.B.WritePText(deletingTrackBackUrlWarnText);
			}
		}

		private void writeThText( NhTr tr, string text )
		{
			using( NhThInline th = tr.CreateThInline() )
			{
				th.WriteText(text);
			}
		}

		private void writeTdText( NhTr tr, string text )
		{
			using( NhTdInline td = tr.CreateTdInline() )
			{
				td.WriteText(text);
			}
		}

		private const string dateTimeFormatForHuman = "yyyyNMMddHHmmssb";
		private const string dateTimeFormatForID = "yyyyMMddHHmmss";
		private void trackBackList()
		{
			myName = "MgbNobNꗗ";
			Item item = GeneralContentsHandler.GetItem(itemID);

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, item.Keyword ) )
			{
				doc.B.WriteHxText(1,myName);
				doc.B.WriteHxText(2,"ΏۃRec");
				doc.B.WritePText("L[[h: " + WriteLib.KeywordToHumanReadableString(item.Keyword));
				doc.B.WritePText("t: " + item.Date.ToString(dateTimeFormatForHuman));
				doc.B.WritePText("^Cg: " + item.Subject);
				doc.B.WritePText("_CWFXg: " + item.GetDigestText());

				using( NhForm form = doc.B.CreateForm(FileNames.AdminFn) )
				{
					form.WriteGetMethod();
					form.WriteHxText(2,"MgbNobN");
					using( NhTable table = form.CreateTable() )
					{
						using( NhTr tr = table.CreateTr() )
						{
							writeThText( tr, "Mt" );
							writeThText( tr, "^Cg" );
							writeThText( tr, "Tv" );
							writeThText( tr, "URL" );
							writeThText( tr, "TCg" );
							writeThText( tr, "IPAhX" );
							writeThText( tr, "폜" );
						}
						TrackBackRecord [] records = TrackBackRecordManager.GetRecords(item.ItemID);
						for( int i=0; i<records.Length; i++ )
						{
							TrackBackRecord record = records[records.Length-i-1];
							using( NhTr tr = table.CreateTr() )
							{
								writeTdText( tr, record.RecievedDateTime.ToString(dateTimeFormatForHuman) );
								writeTdText( tr, record.Title );
								writeTdText( tr, record.Excerpt );
								using( NhTdInline td = tr.CreateTdInline() )
								{
									td.WriteAText(record.Url,record.Url);
								}
								writeTdText( tr, record.SiteName );
								writeTdText( tr, record.IpAddress.ToString() );
								using( NhTdInline td = tr.CreateTdInline() )
								{
									using( NhInput input = td.CreateInput() )
									{
										input.WriteAttribute("type","checkbox");
										input.WriteAttribute("id","rtb" + record.RecievedDateTime.ToString(dateTimeFormatForID));
										input.WriteAttribute("name","rtb" + record.RecievedDateTime.ToString(dateTimeFormatForID));
									}
								}
							}
						}
					}
					using( NhP p = form.CreateP() )
					{
						using( NhInput input = p.CreateInput() )
						{
							input.WriteAttribute("type","hidden");
							input.WriteAttribute("id","id");
							input.WriteAttribute("name","id");
							input.WriteAttribute("value",item.ItemID.ID);
						}
						using( NhInput input = p.CreateInput() )
						{
							input.WriteAttribute("type","hidden");
							input.WriteAttribute("id","fn");
							input.WriteAttribute("name","fn");
							input.WriteAttribute("value","deltbrcvconf");
						}
						using( NhInput input = p.CreateInput() )
						{
							input.WriteAttribute("type","submit");
							input.WriteAttribute("id","ButtonSubmit");
							input.WriteAttribute("name","ButtonSubmit");
							input.WriteAttribute("value","`FbNMgbNobN폜");
						}
					}
				}

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private ArrayList getRecievedTrackBackList( HttpRequest request, TrackBackRecord [] trackBackRecords )
		{
			ArrayList list = new ArrayList();
			foreach( string key in request.QueryString.Keys )
			{
				if( key.StartsWith("rtb") )
				{
					try
					{
						DateTime datetime = DateTime.ParseExact(key.Substring(3),
							TrackBackRecord.TrackBackDateTimeFormat,null);
						foreach( TrackBackRecord r in trackBackRecords )
						{
							if( r.RecievedDateTime == datetime )
							{
								list.Add(datetime);
							}
						}
					}
					catch( FormatException )
					{
						// ԈႢ̓Vvɖ
					}
				}
			}
			return list;
		}

		private void writeRecievedTrackBackList( NhBlock block, ArrayList list, TrackBackRecord [] trackBackRecords, bool doRemove )
		{
			foreach( DateTime datetime in list )
			{
				foreach( TrackBackRecord r in trackBackRecords )
				{
					if( r.RecievedDateTime == datetime )
					{
						block.WriteHxText(3,r.Title);
						block.WritePText("Mt: " + r.RecievedDateTime.ToString(dateTimeFormatForHuman) );
						block.WritePText("TCg: " + r.SiteName );
						block.WritePText("Tv: " + r.Excerpt );
						if( doRemove )
						{
							TrackBackRecordManager.RemoveRecord(this.itemID,datetime);
							block.WritePText(": 폜܂" );
						}
					}
				}
			}
		}

		private void deleteTrackBackRecievedConfirm()
		{
			myName = "MgbNobN폜mF";
			Item item = GeneralContentsHandler.GetItem(itemID);

			TrackBackRecord [] trackBackRecords = TrackBackRecordManager.GetRecords(item.ItemID);
			ArrayList list = getRecievedTrackBackList( Request, trackBackRecords );
			if( list.Count == 0 )
			{
				this.error("폜w肳ꂽLȎMgbNobN1܂B");
				return;
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, item.Keyword ) )
			{
				doc.B.WriteHxText(1,myName);
				doc.B.WritePText("MgbNobN폜悤ƂĂ܂B");
				doc.B.WritePText("{ɍ폜ꍇ́AĹu{ɍ폜ṽNNbNĂB");
				doc.B.WritePText("폜Ȃꍇ͑̃y[WֈړĂB");
				doc.B.WritePText("폜MgbNobN͖߂܂B\ɒӂđ삵ĉB");

				using( NhP p = doc.B.CreateP() )
				{
					p.WriteText("[");
					using( NhA a = p.CreateA() )
					{
						System.Text.StringBuilder sb = new System.Text.StringBuilder();
						sb.Append(FileNames.AdminFn);
						sb.Append("?fn=deltbrcv&id=");
						sb.Append(item.ItemID);
						foreach( DateTime datetime in list )
						{
							sb.Append("&rtb");
							sb.Append(datetime.ToString(TrackBackRecord.TrackBackDateTimeFormat));
							sb.Append("=on");
						}

						a.WriteAttribute("href", sb.ToString() );
						a.WriteText("{ɍ폜");
					}
					p.WriteText("]");
				}
				doc.B.WriteHxText(2,"폜Ώۂ̎MgbNobN");
				writeRecievedTrackBackList(doc.B,list,trackBackRecords,false);

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private void deleteTrackBackRecieved()
		{
			myName = "MgbNobN̍폜";
			Item item = GeneralContentsHandler.GetItem(itemID);

			TrackBackRecord [] trackBackRecords = TrackBackRecordManager.GetRecords(item.ItemID);
			ArrayList list = getRecievedTrackBackList( Request, trackBackRecords );
			if( list.Count == 0 )
			{
				this.error("폜w肳ꂽLȎMgbNobN1܂B");
				return;
			}

			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, myName, item.Keyword ) )
			{
				doc.B.WriteHxText(1,myName);

				doc.B.WriteHxText(2,"폜Ώۂ̎MgbNobN");
				writeRecievedTrackBackList(doc.B,list,trackBackRecords,true);

				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

#if QUICK_HACK_FOR_RECOMPILATION
		private void trackBackWait()
		{
			const int GurdTimeSecond = 15;
			itemID = URIQueryParser.ParseID(Request);
			Response.AppendHeader("REFRESH",GurdTimeSecond.ToString() + "; URL="
				+ FileNames.AdminFn + "?fn=tbgo&id=" + itemID );

			const string myNameSend = "TrackBack pingM҂";
			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, 
					   myNameSend, FullKeyword.NoKeyword ) )
			{
				doc.B.WriteHxText(1,myNameSend);
				doc.B.WritePText("TrackBack pingM҂cc");
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteClassAttr("error");
					p.WriteText("MI܂WebuEU𑀍삵Ȃł҂BWebuEU̐iށA߂Ȃǂ̃{^ACɓ𑀍삵Ȃ悤ɂ肢܂B");
				}
				WriteLib.WriteHorizontalLine(doc.B);
			}
		}
		private void trackBackGo()
		{
			itemID = URIQueryParser.ParseID(Request);
			Response.Redirect(WriteLib.BuildUrlToSendingTrackBackProcedure(
				TrackBackProcedure.TrackBackSendWebProcItem,itemID) );
		}
#endif

		private void Page_Load(object sender, System.EventArgs e)
		{
			keyword = URIQueryParser.ParseKeyword(Request);
			itemID = URIQueryParser.ParseID(Request);
			Item item = GeneralContentsHandler.GetItem(itemID);
			if( !item.IsDummyItem() )
			{
				keyword = item.Keyword;
			}
			if( !ItemListManager.ContentList.IsKeyword(keyword) )
			{
				keyword = FullKeyword.RootKeyword;
			}

			try
			{
				switch( URIQueryParser.ParseFn(Request) )
				{
					case "signout":
						System.Web.Security.FormsAuthentication.SignOut();
						Response.Redirect(FileNames.Default);
						return;
					case "":
						showMesssage();
						return;
				}

				Authorization.ConfirmAccessPermission(User.Identity.Name,keyword);

				switch( URIQueryParser.ParseFn(Request) )
				{
					case "proc":
						WebProcedure.ProcessProcedurePage(Request,
							new AppendHttpResponseHeader(Response.AppendHeader),Response.Output,this);
						return;
					case "delcontconf":
						deleteContentConfirm();
						break;
					case "delcont":
						deleteContent();
						break;
					case "addkw":
						addKeyword();
						break;
					case "fillShortKW":
						fillShortKeyword();
						break;
					case "delkwconf":
						deleteKeywordConfirm();
						break;
					case "delkw":
						deleteKeyword();
						break;
					case "changemasteridconf":
						changeMasterIDConfirm();
						break;
					case "changemasterid":
						changeMasterID();
						break;
					case "addgeneralid":
						addGeneralID();
						break;
					case "delgeneralidconf":
						deleteGeneralIDConfirm();
						break;
					case "delgeneralid":
						deleteGeneralID();
						break;
					case "deltbreqconf":
						deleteTrackBackRequestConfirm();
						break;
					case "deltbreq":
						deleteTrackBackRequest();
						break;
					case "tblist":
						trackBackList();
						break;
					case "deltbrcvconf":
						deleteTrackBackRecievedConfirm();
						break;
					case "deltbrcv":
						deleteTrackBackRecieved();
						break;
#if QUICK_HACK_FOR_RECOMPILATION
					case "tbwait":
						trackBackWait();
						break;
					case "tbgo":
						trackBackGo();
						break;
#endif
					default:
						throw new errorPageException("m̋@\w肳܂B͍s܂B");
				}
			}
			catch( errorPageException e2 )
			{
				error( e2.Message );
			}
			catch( NotPermittedException e2 )
			{
				error( e2.Message );
			}
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}

	public class TrackBackProcedure
	{
		public static void writeSendingNotifyPage(TextWriter writer, object optionalParameter)
		{
			System.Web.UI.Page page = (System.Web.UI.Page)optionalParameter;
			ItemID itemID = URIQueryParser.ParseID(page.Request);
			Item item = GeneralContentsHandler.GetItem(itemID);

			string targetUrl = null;
			lock( item )
			{
				if( page.Request["forceToResendUrl"] != null )
				{
					targetUrl = page.Request["forceToResendUrl"];
				}
				else if( item.GetWaitingTrackBackUrls().Count > 0 )
				{
					targetUrl = (string)item.GetWaitingTrackBackUrls()[0];
				}
			}
			if( targetUrl == null )
			{
				const string myNameDone = "TrackBack pingM̏I";
				using( NhQuickDocument doc = new MyOutputDocument( page.Response.Output, myNameDone, item.Keyword ) )
				{
					doc.B.WriteHxText(1,myNameDone);
					doc.B.WritePText("MΏۃXg̑SĂTrackBack URLւ̑M܂B");
					WriteLib.WriteHorizontalLine(doc.B);
					WriteLib.WriteAdminFooter(doc.B,item.Keyword);
				}
				return;
			}
			const string myNameSend = "TrackBack pingM";
			using( NhQuickDocument doc = new MyOutputDocument( page.Response.Output, myNameSend, item.Keyword ) )
			{
				doc.B.WriteHxText(1,myNameSend);
				doc.B.WritePText("TrackBack pingMcc");
				doc.B.WritePText("M: " + targetUrl );
				using( NhP p = doc.B.CreateP() )
				{
					p.WriteClassAttr("error");
					p.WriteText("MI܂WebuEU𑀍삵Ȃł҂BWebuEU̐iށA߂Ȃǂ̃{^ACɓ𑀍삵Ȃ悤ɂ肢܂B");
				}
				WriteLib.WriteHorizontalLine(doc.B);
			}
		}

		public static void writeSendingResultPage(TextWriter writer, object optionalParameter)
		{
			System.Web.UI.Page page = (System.Web.UI.Page)optionalParameter;
			ItemID itemID = URIQueryParser.ParseID(page.Request);
			Item item = GeneralContentsHandler.GetItem(itemID);

			string targetUrl = null;
			bool succeeded = false;
			bool resending = false;
			try
			{
				lock( item )
				{
					if( page.Request["forceToResendUrl"] != null )
					{
						targetUrl = page.Request["forceToResendUrl"];
						item.MovePendingTrackBackUrlToWaiting(targetUrl);
						item.MoveWaitingTrackBackUrlToProcessing(targetUrl);
						item.Update();
						resending = true;
					}
					else if( item.GetWaitingTrackBackUrls().Count > 0 )
					{
						targetUrl = (string)item.GetWaitingTrackBackUrls()[0];
						item.MoveWaitingTrackBackUrlToProcessing(targetUrl);
						item.Update();
					}
				}
				if( targetUrl == null )
				{
					const string myNameDone = "TrackBack pingM̏I";
					using( NhQuickDocument doc = new MyOutputDocument( page.Response.Output, myNameDone, item.Keyword ) )
					{
						doc.B.WriteHxText(1,myNameDone);
						doc.B.WritePText("MΏۃXg̑SĂTrackBack URLւ̑M܂B");
						WriteLib.WriteHorizontalLine(doc.B);
						WriteLib.WriteAdminFooter(doc.B,item.Keyword);
					}
					return;
				}
				if( !resending && item.GetAlreadySentTrackBackUrls().Contains(targetUrl) )
				{
					const string myNameConfirm = "TrackBack pingdM̊mF";
					using( NhQuickDocument doc = new MyOutputDocument( page.Response.Output, myNameConfirm, item.Keyword ) )
					{
						doc.B.WriteHxText(1,myNameConfirm);
						doc.B.WritePText("w肳ꂽURĹATrackBack pingMsĂ܂B");
						doc.B.WritePText("M: " + targetUrl );
						using( NhP p = doc.B.CreateP() )
						{
							p.WriteText("[");
							p.WriteAText(WriteLib.BuildUrlToSendingTrackBackProcedure(TrackBackProcedure.TrackBackSendWebProcItem,itemID,targetUrl),
								"TrackBack URLɑ΂čđM");
							p.WriteText("][");
							p.WriteAText(FileNames.AdminFn + "?fn=deltbreqconf&id=" + itemID.ID + "&url=" + HttpUtility.UrlEncode(targetUrl),
								"TrackBack URL폜āATrackBack ping𑱂");
							p.WriteText("]");
						}
						WriteLib.WriteHorizontalLine(doc.B);
						doc.B.WritePText("䒍: 2̃NȊȎsƁAȌTrackBack pingMɍƂi܂ȂȂAM܂B");
						WriteLib.WriteHorizontalLine(doc.B);
					}
					return;
				}

				// G[UĨeXg͉LsLɂčs
				// throw new ApplicationException("test");
				TrackBackTransmitter tb = new TrackBackTransmitter(WriteLib.BuildContentAbsoluteUrl(page.Request.Url,item.ItemID),
					targetUrl,item.Subject,item.GetDigestText(),
					SectionDefManager.GetSectionDef(item.Keyword).Title);

				if( !tb.Succeeded )
				{
					throw new ApplicationException(tb.Message);
				}

				// Todo: ping it, set succeeded
				succeeded = true;
			}
			catch( Exception e )
			{
				const string myNameError = "TrackBack pingM̃G[";
				using( NhQuickDocument doc = new MyOutputDocument( page.Response.Output, myNameError, item.Keyword ) )
				{
					doc.B.WriteHxText(1,myNameError);
					doc.B.WritePText("TrackBack ping̑MɎs܂B");
					doc.B.WritePText("M: " + targetUrl );
					using( NhP p = doc.B.CreateP() )
					{
						p.WriteText("[");
						p.WriteAText(WriteLib.BuildUrlToSendingTrackBackProcedure(TrackBackProcedure.TrackBackSendWebProcItem,itemID,targetUrl),
							"TrackBack URLɑ΂čđM");
						p.WriteText("][");
						p.WriteAText(WriteLib.BuildUrlToSendingTrackBackProcedure(TrackBackProcedure.TrackBackSendWebProcItem,itemID),
							"TrackBack URLyfBOXgɓTrackBack ping𑱂");
						p.WriteText("][");
						p.WriteAText(FileNames.AdminFn + "?fn=deltbreqconf&id=" + itemID.ID + "&url=" + HttpUtility.UrlEncode(targetUrl),
							"TrackBack URL폜āATrackBack ping𑱂");
						p.WriteText("]");
					}
					doc.B.WritePText("yfBOXgɓꂽTrackBack URĹAƂōĂёM݂邱Ƃł܂B"
						+"Rec̍쐬y[WŁAyfBOXĝURLIA[ITrackBack URLēxgbNobNMΏۂ]{^NbNĉB");
					WriteLib.WriteHorizontalLine(doc.B);
					doc.B.WritePText("䒍: 3̃NȊȎsƁAȌTrackBack pingMɍƂi܂ȂȂAM܂B");
					WriteLib.WriteHorizontalLine(doc.B);
					doc.B.WriteHxText(2,"O");
					StringReader reader = new StringReader(e.ToString());
					while( true )
					{
						string s = reader.ReadLine();
						if( s == null ) break;
						doc.B.WritePText(s);
					}
					WriteLib.WriteHorizontalLine(doc.B);
				}
				return;
			}
			finally
			{
				if( targetUrl != null )
				{
					if( succeeded )
					{
						item.MoveProcessingTrackBackUrlToAlreadySent(targetUrl);
						item.Update();
					}
					else
					{
						item.MoveProcessingTrackBackUrlToPending(targetUrl);
						item.Update();
					}
				}
			}

			if( succeeded )
			{
				page.Response.Redirect(WriteLib.BuildUrlToSendingTrackBackProcedure(TrackBackProcedure.TrackBackSendWebProcItem,itemID) );
			}
		}

		public static WebProcedureItem TrackBackSendWebProcItem = new WebProcedureItem("tbsend",
			FileNames.AdminFn,new WriteNotifyPage(writeSendingNotifyPage),
			new WriteResultPage(writeSendingResultPage) );
	}
}
